//+------------------------------------------------------------------+
//|                                                      AtR_Lnx.mq4 |
//|                                                                  |
//|                                               Written by Linuxser|   
//|                                       http://www.linuxser.com.ar |                                
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 4
#property  indicator_color1  C'221,57,34'   
#property  indicator_color2  C'49,139,206'    
#property  indicator_color3  C'43,89,213'  
#property  indicator_color4  C'197,58,107'  

//---- indicator parameters
extern int AtRper=14;
extern int Signal=6;
extern int MODE_MA=0;
extern int ArrowStyle= 159;
//---- indicator buffers

double AtRBuffer[];
double SignalBuffer[];
double LAtRBuffer[];
double AtRUpBuffer[];
double AtRDownBuffer[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(5);
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexLabel(0,"AtR");
   SetIndexStyle(1,DRAW_LINE);
   SetIndexLabel(1,"Signal");
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,ArrowStyle);
   SetIndexLabel(2,NULL);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,ArrowStyle);
   SetIndexLabel(3,NULL);
   SetIndexStyle(4,DRAW_NONE);
   SetIndexLabel(4,NULL);
   SetIndexDrawBegin(0,Signal);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);
//---- 3 indicator buffers mapping

   SetIndexBuffer(0,AtRBuffer); 
   SetIndexBuffer(1,SignalBuffer);   
   SetIndexBuffer(2,AtRUpBuffer);
   SetIndexBuffer(3,AtRDownBuffer);
   SetIndexBuffer(4,LAtRBuffer); 
   Print("cannot set indicator buffers!");
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("AtR Lnx v1("+AtRper+","+Signal+")");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Average of Oscillator                                     |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st additional buffer
   for(int i=0; i<limit; i++){
      AtRBuffer[i]=iATR(NULL,0,AtRper,i);
   }
//---- signal line counted in the 2-nd additional buffer
   for(i=0; i<limit; i++){
      SignalBuffer[i]=iMAOnArray(AtRBuffer,Bars,Signal,0,MODE_MA,i);
   }
//---- main loop
   for(i=0; i<limit; i++){
      LAtRBuffer[i]=(AtRBuffer[i]-SignalBuffer[i]);
      
      if(LAtRBuffer[i]>0){
         AtRUpBuffer[i]=0;
         AtRDownBuffer[i]=EMPTY_VALUE;
      }else if(LAtRBuffer[i]<0){
         AtRDownBuffer[i]=0;
         AtRUpBuffer[i]=EMPTY_VALUE;
      }else{
         AtRUpBuffer[i]=0;
         AtRDownBuffer[i]=0;
      }
   }
//---- done
   return(0);
  }
//+------------------------------------------------------------------+

